# 🔥 Stonelog - 10 Billion Times Better Logging!

The most scientifically badass logging library from the Kingdom of Science!

[![Kingdom of Science Approved](https://img.shields.io/badge/Approved%20By-Kingdom%20of%20Science-blueviolet)]()
[![SO BADASS](https://img.shields.io/badge/Science-SO_BADASS!-blueviolet)]()
[![10 BILLION](https://img.shields.io/badge/10_Billion%25-Scientific-blueviolet)]()

## 🚀 Why Stonelog?

- Dr.Stone-themed logging that Senku would approve
- Dramatic error messages worthy of a lab explosion
- Character quotes from your favorite scientists
- 10 billion watts of scientific swagger

## 💥 Installation

```bash
go get gitstormr.dev/stone-utils/stonelog@latest
```

## ⚡ Initialization

```go
package main

import (
	"gitstormr.dev/stone-utils/stonelog"
)

func main() {
	// Basic configuration (INFO level by default)
	stonelog.InitStoneLog(stonelog.INFO, false, false) // false = text mode (true = JSON), false = keep suffixes (true = don't add character quotes)

	// Example logs
	stonelog.Observation("System initialized successfully!")
	stonelog.Failure("Reactor core temperature critical!")
}
```

## 📜 Log Levels (Scientific Style!)

| Function      | 	Level Equivalent	 | Example Output                                   |
|---------------|--------------------|--------------------------------------------------|
| Trace()       | 	TRACE	            | 🔍 Science traces: Entering function X           |
| Debug()       | 	DEBUG             | 	🤔 Hypothesis forming: Variable X = 42          |
| Observation() | 	INFO              | 	✅ Experiment successful: User logged in         |
| Hypothesis()  | 	WARN              | 	⚠️ Anomaly detected: High memory usage          |
| Failure()	    | ERROR              | 	💥 Critical malfunction: DB disconnected        |
| Meltdown()	   | FATAL              | 	☠️ FINAL EXPERIMENT FAILED: Server exploded     |
| Panic()	      | PANIC              | 	🚨 CHAIN REACTION DETECTED: Unrecoverable error |

## 🎛️ Changing Log Level

```go
// Dynamic change! (e.g., enable DEBUG in production)
stonelog.SetLogLevel(stonelog.DEBUG)
```

## 🔬 JSON Mode (For Production)

```go
stonelog.InitStoneLab(stonelog.STONE_DEBUG, true, false) // true = JSON, false = Keep suffixes
// Output: {"time":"2023-07-15T12:00:00Z","level":"OBSERVATION","message":"✅ Experiment successful: System ready","caller":"main.go:15"}
```

## **🚨 WINDOWS COLOR SUPPORT NOTICE 🚨**

*"HEY WINDOWS USERS! YOUR TERMINALS NEED SOME SCIENCE!" - Chrome*

🔬 **Current Limitations:**
- Colors don't work in old Windows Command Prompt (CMD)
- Looks boring in black & white (like stone tablets!)
- Works perfectly in modern terminals

💡 **Senku-Approved Solutions:**
1. Install **Windows Terminal** (Microsoft Store)
2. Use **WSL** (Windows Subsystem for Linux)
3. Try **VS Code** or **Git Bash**

*"This temporary setback represents just 0.0000001% of our scientific progress!"*
- **Dr. Senku Ishigami**

*(Chrome whispers: "Pssst... Linux terminals are SO BADASS!")* 🐧🔥

**Join the Scientific Revolution!**

> "This isn't just logging - it's 10 billion percent scientific progress!" - Senku Ishigami

Kingdom of Science Approved

(Now with 100% more Chrome screaming "SO BADASS!")